﻿// <auto-generated />
using System;
using Microsoft.EntityFrameworkCore;
using Microsoft.EntityFrameworkCore.Infrastructure;
using Microsoft.EntityFrameworkCore.Migrations;
using Microsoft.EntityFrameworkCore.Storage.ValueConversion;
using Npgsql.EntityFrameworkCore.PostgreSQL.Metadata;
using Trader.Infrastructure.Data;

#nullable disable

namespace Trader.Infrastructure.Migrations
{
    [DbContext(typeof(TraderContext))]
    [Migration("20231025221540_Add initial")]
    partial class Addinitial
    {
        /// <inheritdoc />
        protected override void BuildTargetModel(ModelBuilder modelBuilder)
        {
#pragma warning disable 612, 618
            modelBuilder
                .HasAnnotation("ProductVersion", "7.0.11")
                .HasAnnotation("Relational:MaxIdentifierLength", 63);

            NpgsqlModelBuilderExtensions.UseIdentityByDefaultColumns(modelBuilder);

            modelBuilder.Entity("Trader.Core.Entities.Fund", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("uuid");

                    b.Property<int>("Currency")
                        .HasColumnType("integer");

                    b.Property<string>("Name")
                        .IsRequired()
                        .HasColumnType("text");

                    b.HasKey("Id");

                    b.ToTable("Funds", (string)null);

                    b.UseTptMappingStrategy();
                });

            modelBuilder.Entity("Trader.Core.Entities.Bond", b =>
                {
                    b.HasBaseType("Trader.Core.Entities.Fund");

                    b.Property<double>("Price")
                        .HasColumnType("double precision");

                    b.Property<float>("Yield")
                        .HasColumnType("real");

                    b.ToTable("Bonds", null, t =>
                        {
                            t.Property("Id")
                                .HasColumnName("FundId");
                        });
                });

            modelBuilder.Entity("Trader.Core.Entities.Equity", b =>
                {
                    b.HasBaseType("Trader.Core.Entities.Fund");

                    b.Property<int>("Exchange")
                        .HasColumnType("integer");

                    b.Property<int>("Sector")
                        .HasColumnType("integer");

                    b.Property<double>("Value")
                        .HasColumnType("double precision");

                    b.ToTable("Equities", null, t =>
                        {
                            t.Property("Id")
                                .HasColumnName("FundId");
                        });
                });

            modelBuilder.Entity("Trader.Core.Entities.ExchangeTradedFund", b =>
                {
                    b.HasBaseType("Trader.Core.Entities.Fund");

                    b.Property<int>("DistributionStatus")
                        .HasColumnType("integer");

                    b.Property<double>("Price")
                        .HasColumnType("double precision");

                    b.Property<short>("RiskRating")
                        .HasColumnType("smallint");

                    b.ToTable("ExchangeTradedFunds", null, t =>
                        {
                            t.Property("Id")
                                .HasColumnName("FundId");
                        });
                });

            modelBuilder.Entity("Trader.Core.Entities.MutualFund", b =>
                {
                    b.HasBaseType("Trader.Core.Entities.Fund");

                    b.Property<int>("DistributionStatus")
                        .HasColumnType("integer");

                    b.Property<double>("NetAssetValue")
                        .HasColumnType("double precision");

                    b.Property<short>("RiskRating")
                        .HasColumnType("smallint");

                    b.ToTable("MutualFunds", null, t =>
                        {
                            t.Property("Id")
                                .HasColumnName("FundId");
                        });
                });

            modelBuilder.Entity("Trader.Core.Entities.Bond", b =>
                {
                    b.HasOne("Trader.Core.Entities.Fund", null)
                        .WithOne()
                        .HasForeignKey("Trader.Core.Entities.Bond", "Id")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();
                });

            modelBuilder.Entity("Trader.Core.Entities.Equity", b =>
                {
                    b.HasOne("Trader.Core.Entities.Fund", null)
                        .WithOne()
                        .HasForeignKey("Trader.Core.Entities.Equity", "Id")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();
                });

            modelBuilder.Entity("Trader.Core.Entities.ExchangeTradedFund", b =>
                {
                    b.HasOne("Trader.Core.Entities.Fund", null)
                        .WithOne()
                        .HasForeignKey("Trader.Core.Entities.ExchangeTradedFund", "Id")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();
                });

            modelBuilder.Entity("Trader.Core.Entities.MutualFund", b =>
                {
                    b.HasOne("Trader.Core.Entities.Fund", null)
                        .WithOne()
                        .HasForeignKey("Trader.Core.Entities.MutualFund", "Id")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();
                });
#pragma warning restore 612, 618
        }
    }
}
